{ *************************************************************************** }
{                                                                             }
{ Chat Demo                                                                   }
{                                                                             }
{ Copyright (c) 2004 Sergey Mishin <mishinmail@mail.ru>                       }
{                                                                             }
{ This program is free software; you can redistribute it and/or               }
{ modify it under the terms of the GNU General Public                         }
{ License as published by the Free Software Foundation; either                }
{ version 2 of the License, or (at your option) any later version.            }
{                                                                             }
{ This program is distributed in the hope that it will be useful,             }
{ but WITHOUT ANY WARRANTY; without even the implied warranty of              }
{ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU           }
{ General Public License for more details.                                    }
{                                                                             }
{ You should have received a copy of the GNU General Public License           }
{ along with this program; see the file COPYING.  If not, write to            }
{ the Free Software Foundation, Inc., 59 Temple Place - Suite 330,            }
{ Boston, MA 02111-1307, USA.                                                 }
{                                                                             }
{ *************************************************************************** }

unit Unit2;

interface

uses
  SysUtils, Types, Classes, Variants, QTypes, QGraphics, QControls, QForms,
  QDialogs, QStdCtrls, QMenus, QImgList, QComCtrls, QExtCtrls,
  QFontComboBox, QColorComboBox, QButtons, IdUDPServer, IdBaseComponent,
  IdComponent, IdUDPBase, IdUDPClient, QActnList,IniFiles,libc,IdSocketHandle;

type
  TForm2 = class(TForm)
    MainMenu1: TMainMenu;
    N1: TMenuItem;
    N6: TMenuItem;
    N7: TMenuItem;
    N8: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    N5: TMenuItem;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ImageList1: TImageList;

    Memo1: TMemo;
    ToolButton8: TToolButton;
    ToolButton9: TToolButton;
    StatusBar1: TStatusBar;
    Splitter1: TSplitter;
    Panel1: TPanel;
    chk1251: TCheckBox;
    Image2: TImage;
    Image3: TImage;
    Image4: TImage;
    cboRecipients: TComboBox;
    edtSendString: TEdit;
    SpeedButton1: TSpeedButton;
    IdUDPClient1: TIdUDPClient;
    IdUDPServer1: TIdUDPServer;
    SaveDialog1: TSaveDialog;
    Timer1: TTimer;
    ActionList1: TActionList;
    actClear: TAction;
    actSave: TAction;
    N9: TMenuItem;
    RecipientLabel: TLabel;
    FontDialog1: TFontDialog;
    Label1: TLabel;
    Label2: TLabel;
    procedure Timer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure actClearExecute(Sender: TObject);
    procedure actSaveExecute(Sender: TObject);
    procedure IdUDPServer1UDPRead(Sender: TObject; AData: TStream;
      ABinding: TIdSocketHandle);
    procedure SpeedButton1Click(Sender: TObject);
    procedure ToolButton1Click(Sender: TObject);
    procedure ToolButton2Click(Sender: TObject);
    procedure ToolButton3Click(Sender: TObject);  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form2: TForm2;
  Recipient,DefaultHost : String;
  FormIni: TIniFile;
  IniPath : String;

const
char_cp1251: array[0..160] of Char = ('q','w','e','r','t','y','u','i','o','p','[',']',
                                           'a','s','d','f','g','h','j','k','l',';',
                                           'z','x','c','v','b','n','m',',','.','/',
                                           'Q','W','E','R','T','Y','U','I','O','P',
                                           'A','S','D','F','G','H','J','K','L','''',
                                           'Z','X','C','V','B','N','M',
                                           '','','','','','','','','','','','',
                                           '','','','','','','','','','','',
                                           '','','','','','','','','',
                                           '','','','','','','','','','','','',
                                           '','','','','','','','','','','',
                                           '','','','','','','','','',' ',
                                           '!','@','#','$','%','*','(',')','-','_','+','=','?','<','>','&',
                                           '0','1','2','3','4','5','6','7','8','9',':','"','''','^','{','}',
                                           '\','|','~','`','');

char_KOI8: array[0..160] of Char = ('q','w','e','r','t','y','u','i','o','p','[',']',
                                           'a','s','d','f','g','h','j','k','l',';',
                                           'z','x','c','v','b','n','m',',','.','/',
                                           'Q','W','E','R','T','Y','U','I','O','P',
                                           'A','S','D','F','G','H','J','K','L','''',
                                           'Z','X','C','V','B','N','M',
                                           '','','','','','','','','','','','',
                                           '','','','','','','','','','','',
                                           '','','','','','','','','',
                                           '','','','','','','','','','','','',
                                           '','','','','','','','','','','',
                                           '','','','','','','','','',' ',
                                           '!','@','#','$','%','*','(',')','-','_','+','=','?','<','>','&',
                                           '0','1','2','3','4','5','6','7','8','9',':','"','''','^','{','}',
                                           '\','|','~','`','');


implementation

{$R *.xfm}
function KOI8ToCp1251(Input:String):String ;
var i,j,iTextLength : integer;
    letter,s: string;
begin
iTextLength :=Length(Input);
s:='';

for i :=1  to iTextLength do
begin
   letter:=copy(Input,i,1);
   for  j:=0  to 160  do
    begin
       if letter=char_KOI8[j] then
       begin
         s:=s+char_cp1251[j];
         //exit;
       end;
    end;
end;

Result:=s;

end;

procedure TForm2.Timer1Timer(Sender: TObject);
begin
StatusBar1.Panels[1].Text:=' : '+TimeToStr(Time);
end;

procedure TForm2.FormCreate(Sender: TObject);
var
 PPWRec  : PPasswordRecord;
 uid     : Integer;

begin
// Load Ini
  IniPath:=ExtractFilePath(Application.ExeName)+ 'chat.ini';
  FormIni := TIniFile.Create(IniPath);
  with FormIni do
  begin
    //Defaults
    DefaultHost:=ReadString('Defaults', 'DefaultHost', '192.168.121.255');

    // UDPClient
    IdUDPClient1.BufferSize:=ReadInteger('UDPClient', 'BufferSize', 8192);
    IdUDPClient1.Port:=ReadInteger('UDPClient', 'Port', 11245);
    IdUDPClient1.Host:=ReadString('UDPClient', 'Host', '192.168.121.255');

    // UDP Server
    IdUDPServer1.BufferSize:=ReadInteger('UDPServer', 'BufferSize', 8192);
    IdUDPServer1.DefaultPort:=ReadInteger('UDPServer', 'DefaultPort', 11245);

    //Other users
    ReadSection('Users',cboRecipients.Items);
    cboRecipients.Items.Add('<>');
    cboRecipients.ItemIndex:=cboRecipients.Items.Count-1;

    Free;
   end;

  //IdUDPClient1.Active:=True;
  //IdUDPServer1.Active:=True;

// Load my UID
 uid := getuid;
 PPWRec := getpwuid(uid);
 Recipient := PPWRec^.pw_name;


end;

procedure TForm2.actClearExecute(Sender: TObject);
begin
Memo1.Clear;
end;

procedure TForm2.actSaveExecute(Sender: TObject);
var
  FileTarget: TextFile;
  i: integer;
begin
   if SaveDialog1.Execute then
   begin
     // Write Target
      AssignFile(FileTarget, SaveDialog1.FileName);
      Rewrite(FileTarget);
      for  i:=0  to Memo1.Lines.Count-1 do
      begin
        Writeln(FileTarget, Memo1.Lines[i]);
      end;
   CloseFile(FileTarget);
   end;

end;

procedure TForm2.IdUDPServer1UDPRead(Sender: TObject; AData: TStream;
  ABinding: TIdSocketHandle);
var
        StringFormatedStream: TStringStream;
        s: String;
begin
     StringFormatedStream := TStringStream.Create('');
     StringFormatedStream.CopyFrom(AData,AData.Size);
     Memo1.Lines.Add(StringFormatedStream.DataString);
     StatusBar1.Panels[0].Text:='    '+timeToStr(Now);
     ABinding.SendTo(ABinding.PeerIP, ABinding.PeerPort, s[1], Length(s));
     StringFormatedStream.Free;

end;

procedure TForm2.SpeedButton1Click(Sender: TObject);
var
        sSendSting: string;
begin
  IdUDPClient1.Active:=False;
// Load Ini
  FormIni := TIniFile.Create(IniPath);
  with FormIni do
  begin
    // Read user address
    if cboRecipients.Text='<>' then
    begin
       IdUDPClient1.Host:= DefaultHost;
       IdUDPClient1.BroadcastEnabled:=True;
    end
    else
    begin
     IdUDPClient1.Host:=ReadString('Users', cboRecipients.Text, '');
     IdUDPClient1.BroadcastEnabled:=False;
    end;
    Free;
   end;

  IdUDPClient1.Active:=True;

  if edtSendString.Text <>'' then
  begin
     sSendSting:='     ' + TimeToStr(Now)+' '+cboRecipients.Text+ '  '+RecipientLabel.Caption+':   '+edtSendString.Text;
      if chk1251.Checked then IdUDPClient1.Send(KOI8ToCp1251(sSendSting))
      else IdUDPClient1.Send(sSendSting);

      //Memo1.Lines.Add('----------------------------------------------------------------------------------------------------------');
      Memo1.Lines.Add(RecipientLabel.Caption+' --> '+cboRecipients.Text+' (' + TimeToStr(Now)+') :   '+edtSendString.Text);
      //Memo1.Lines.Add('----------------------------------------------------------------------------------------------------------');
  end
  else
  begin
     StatusBar1.Panels[0].Text:='!        .';
     Beep;
  end;


end;

procedure TForm2.ToolButton1Click(Sender: TObject);
begin
Memo1.Clear;
end;

procedure TForm2.ToolButton2Click(Sender: TObject);
var
  FileTarget: TextFile;
  i: integer;
begin
   if SaveDialog1.Execute then
   begin
     // Write Target
      AssignFile(FileTarget, SaveDialog1.FileName);
      Rewrite(FileTarget);
      for  i:=0  to Memo1.Lines.Count-1 do
      begin
        Writeln(FileTarget, Memo1.Lines[i]);
      end;
   CloseFile(FileTarget);
   end;

end;

procedure TForm2.ToolButton3Click(Sender: TObject);
begin
    if FontDialog1.Execute then  Memo1.Font:=FontDialog1.Font;
end;

end.
